#include <bits/stdc++.h>
#define ll long long
using namespace std;

int main(){
ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
short t; cin >> t;
ll n, k; cin >> n >> k;
ll a[n+4];
bool p = true;
for ( int i = 0; i < n; i++ ){
    cin >> a[i];
    if ( a[i] != a[0] ){
        p = false;
    }
}
if ( (n-k)%2 != 0 ){
    cout << "NE";
}
else{
if ( t == 0 ){
        if (p == true){
            if ( n-1 <= a[0] ){
                if ( k != n-1 ){
                    cout << "NE";
                }
                else{
                    cout << "DA";
                }
            }
            else{
                if ( k == a[0] + (n-a[0])%2 ){
                    cout << "DA";
                }
                else{
                    cout << "NE";
                }
            }
        }
}
else{
            if (p == true){
            if ( n-1 <= a[0] ){
                if ( k != n-1 ){
                    cout << "NE";
                }
                else{
                    cout << "DA";
                    for ( int i = 0; i < n; i++ ){
                        cout << a[0] << " ";
                    }
                }
            }
            else{
                if ( k == a[0] + (n-a[0])%2 ){
                    cout << "DA";
                    for ( int i = 0; i < n; i++ ){
                        cout << a[0] << " ";
                    }
                }
                else{
                    cout << "NE";
                }
            }
        }
    }
}


return 0;
}